# -*- coding: UTF-8 -*-

#=======================================================================
import rdflib
from oort.sitebase import ResourceViewer, Display, Aspect
from oort.util.graphs import load_dir

from myapp.queries import *
from myapp.ns import *
#=======================================================================


MYAPP_BASE_URI = "http://myapp.example.org/"


class MyappResourceViewer(ResourceViewer):

    resourceBase = MYAPP_BASE_URI
    trailSep = "/"

    langOrder = 'en', 'sv'

    class HtmlDisplay(Display):
        name = "html"
        default = True
        outputMethod = 'xhtml'
        contentType = 'text/html'
        outputEncoding  = 'iso-8859-1'
        templateBase = "myapp/view/html"
        globalQueries = {
                'site': WebSite.bound_with(rdflib.URIRef(MYAPP_BASE_URI)),
                'itemInfo': ItemInfo,
            }
        aspects = [
                Aspect(RDFS.Resource, "unknown.xhtml", {}),
                Aspect(APP.WebSite, "website.xhtml"),
                Aspect(APP.SiteNode, "sitenode.xhtml").using(node=SiteNode),
                Aspect(APP.TypeListing, "typelisting.xhtml").using(listing=TypeListing),
                Aspect(FOAF.Person, "person.xhtml").using(person=Person),
                Aspect(DOAP.Project, "project.xhtml").using(project=Project),
                Aspect(SKOS.Topic, "topic.xhtml").using(topic=FullTopic),
            ]


DATA_PATH = 'data'

def graph_factory():
    graph = rdflib.ConjunctiveGraph()
    def handle_load_error(e, fpath):
        print "error in %s" % fpath
    load_dir(graph, DATA_PATH, errorHandler=handle_load_error)
    return graph


